/*
 * Author:          Patrick-Christopher Mattulat
 * Co-Author:       Claude Sonnet 4.6 (LLM)
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2020-10-17
 * Changed:         2026-06-23
 *
 * */

#ifndef LS_STD_XML_PARSE_PARAMETER_HPP
#define LS_STD_XML_PARSE_PARAMETER_HPP

#include "XmlNode.hpp"
#include <cstdint>
#include <ls-std/os/dynamic-goal.hpp>
#include <memory>

/*
 * @doc: class(name: 'XmlParseParameter', package: 'io')
 * @doc: io.XmlParseParameter.description('This class holds information regarding parsing an XML tree.')
 * */

namespace ls::standard::io
{
  class LS_STD_DYNAMIC_GOAL XmlParseParameter
  {
    public:

      XmlParseParameter();
      ~XmlParseParameter();

      [[nodiscard]] uint8_t getLevel() const;
      [[nodiscard]] ::std::shared_ptr<ls::standard::io::XmlNode> getNode() const;
      void setLevel(const uint8_t &_level);
      void setNode(const ::std::shared_ptr<ls::standard::io::XmlNode> &_node);

    private:

      uint8_t level{};
      ::std::shared_ptr<ls::standard::io::XmlNode> node{};

      void _setNode(const ::std::shared_ptr<ls::standard::io::XmlNode> &_node);
  };
}

#endif
